//+------------------------------------------------------------------+
//|                                          StepMAExpert_v1.451.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#include <stdlib.mqh>

//
//
//
//
//

extern string     Expert_Name       = "---- Step_MA_Expert---";
extern bool       EcnBroker         = true;
extern bool       UseAutoMagic      = true;
extern int        ManualMagic       = 91919192;
extern int        Slippage          = 3;

extern string     Main_Parameters   = " Trade Volume & Trade Method";
extern double     Lots              = 0.01;
extern int        TrailingStopMode  = 1;     // Trailing Stop Mode Switch (0-without TS, 1-with TS) 
extern double     TrailingStop      = 0;     // Classic Trailing Stop Value  
extern bool       SwingTrade        = true;  // Swing or Reverse Trade Switch
extern int        SessionStart      = 8;     // Start Hour of Trade Session 
extern int        SessionEnd        = 24;    // End Hour of Trade Session
extern int        FilterPeriod      = 0;     // Period of filter (EMA)

extern string     Long_Trade        = " Input data for Long Positions";
extern double     StepSizeLong      = 10;     // Step Size (in points)
extern bool       HighLowLong       = false;  // High/Low Mode Switch (if true than more sensitive)
extern int        MomPeriodLong     = 1;
extern double     DeltaLong         = 4;       // StepMA Momentum Level(in points)
extern double     DeltaLongExit     = 3;       // StepMA Momentum Level for Exit (in points)
extern double     StopSizeLong      = 60.0;    // Step Size for Trailing Stop (in points) 
extern double     ProfitSizeLong    = 360.0;   // Step Size for Trailing Profit (in points)
extern double     InitialStopLong   = 10;      // Initial Stop Value (in points)
extern double     TakeProfitLong    = 490;     // Take Profit Value (in points)
extern double     BreakEvenLong     = 80;      // BreakEven Level (in points)
extern double     BreakEvenGapLong  = 40;      // BreakEven Gap (in points)

extern string     Short_Trade       = " Input data for Short Positions ";
extern double     StepSizeShort     = 10;      // Step Size (in points)
extern bool       HighLowShort      = false;   // High/Low Mode Switch (if true than more sensitive)
extern int        MomPeriodShort    = 1;
extern double     DeltaShort        = 7;       // StepMA Momentum Level (in points)
extern double     DeltaShortExit    = 1;       // StepMA Momentum Level for Exit (in points)
extern double     StopSizeShort     = 20.0;    // Step Size for Trailing Stop (in points)
extern double     ProfitSizeShort   = 250.0;   // Step Size for Trailing Profit (in points)
extern double     InitialStopShort  = 50;      // Initial Stop Value (in points)
extern double     TakeProfitShort   = 40;      // Take Profit Value (in points)
extern double     BreakEvenShort    = 10;      // BreakEven Level (in points)
extern double     BreakEvenGapShort = 12;      // BreakEven Gap (in points)

extern string     MM_Parameters = " MoneyManagement by L.Williams ";
extern bool       MM                = true;    //  Switch
extern double     Risk              = 1.00;    // Risk Factor
extern double     LossMax           = 501;     // Maximum Loss by 1 Lot

//
//
//
//
//

int      Length=10;
double   Kv=1.0;     
int      trend=0,TradeSignal=0,ExitSignal=0,prevtrendlong=0,matrendlong=0,
         matrendshort=0,prevtrendshort=0,Kz=0,mode=0,Type=0, numords;
double   Smin1=0,Smax1=0,Price=0,PriceStop=0, BuyProfit=0, SellProfit=0;
double   line0long=0,line1long=0,bsmin1long=0,bsmax1long=0, StepLong=0,Smin1long=0,Smax1long=0, 
         line0short=0,line1short=0,bsmin1short=0,bsmax1short=0,StepShort=0,Smin1short=0,Smax1short=0, 
         point=0, spread=0;
double   BuyStop=0,SellStop=0,ATRmin=10000,ATRmax=0,bsmax2=0,bsmin2=0;
double   PointRatio = 1;
int      b=0,cnt=0, digit=0;
bool     FirstTime = false;
string   s_symbol;
int      MAGIC;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init() 
{
  FirstTime = true;
  s_symbol  = Symbol();
  
  digit  = MarketInfo(s_symbol,MODE_DIGITS);
  if (digit==2 || digit==4)  PointRatio = 1;
  if (digit==3 || digit==5) PointRatio = 10;
  if (digit==6)             PointRatio = 100;
  point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
   
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()  {   return(0); }

//
//
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
{
   int total,ticket;
   TrailProfit();
   
   //
   //
   //
   //
   //
   
   if (Bars>b)
   {      
   b=Bars;
   
   //
   //
   //
   //
   //
     
   double line1longexit  = line0long;
   if (MomPeriodLong    == 1 ) prevtrendlong = matrendlong;
   else prevtrendlong    = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeLong,0,0,0,HighLowLong,0,0,5,MomPeriodLong+1);
        line1long        = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeLong,0,0,0,HighLowLong,0,0,0,MomPeriodLong+1);
        line0long        = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeLong,0,0,0,HighLowLong,0,0,0,1); 
        matrendlong      = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeLong,0,0,0,HighLowLong,0,0,5,1);   
   
   double line1shortexit = line0short;
   if (MomPeriodShort   == 1 ) prevtrendshort = matrendshort;
   else prevtrendshort   = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeShort,0,0,0,HighLowShort,0,0,5,MomPeriodShort+1);
        line1short       = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeShort,0,0,0,HighLowShort,0,0,0,MomPeriodShort+1); 
        line0short       = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeShort,0,0,0,HighLowShort,0,0,0,1); 
        matrendshort     = iCustom(s_symbol,0,"StepMA_v8EA",Length,Kv,StepSizeShort,0,0,0,HighLowShort,0,0,5,1);
   
   
   if(StepSizeLong > 0) StepLong  = Kv*StepSizeLong*point; 
   if(StepSizeShort> 0) StepShort = Kv*StepSizeShort*point;
	
	bsmin1long = line0long - ProfitSizeLong*point;
   bsmax1long = line0long + ProfitSizeLong*point;
	  
	double slinelong  = line0long;
	Smin1long         = slinelong - StopSizeLong*point;
	Smax1long         = slinelong + StopSizeLong*point; 
    
   bsmin1short       = line0short - ProfitSizeShort*point;
   bsmax1short       = line0short + ProfitSizeShort*point;
	  
	double slineshort = line0short;
	Smin1short        = slineshort - StopSizeShort*point;
	Smax1short        = slineshort + StopSizeShort*point; 
	
	   
      bool TimeCondition = false;
      TimeCondition = (TimeHour(CurTime()) >= SessionStart && TimeHour(CurTime()) <=SessionEnd);

      // 
      //
      //
      //
      //
      
      if (FilterPeriod > 0)
      {
      bool BuyFilter = false;
      BuyFilter = (Close[1]>iMA(s_symbol,0,FilterPeriod,0,MODE_EMA,0,1));
      
      bool SellFilter = false; 
      SellFilter = (Close[1]<iMA(s_symbol,0,FilterPeriod,0,MODE_EMA,0,1));
      }
      else { BuyFilter = true; SellFilter = true; }
      
      //
      //
      //
      //
      //
      
      if(!SwingTrade) TradeSignal=0; 	
   
      if (BuyFilter  && line0long  - line1long  > DeltaLong*point  && line1long > 0 && prevtrendlong < 0 ) TradeSignal= 1;
      if (SellFilter && line1short - line0short > DeltaShort*point && line1short> 0 && prevtrendshort > 0) TradeSignal= -1;
    
      if (line1longexit-line0long  > DeltaLongExit* point)  ExitSignal= -1;
      if (line0short-line1shortexit >DeltaShortExit*point)  ExitSignal= 1;
            
      //-----------------------------
      //
      //
      //
      //
      
      total=OrdersTotal();
	   for (cnt=0;cnt<total;cnt++)
      { 
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);   
       mode=OrderType();
       if (OrderSymbol()==s_symbol && OrderMagicNumber() == MAGIC)
       {    
         if (ExitSignal < 0)
         {
            if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*point,Yellow);  }
         }
         
         // - SELL Orders 
         //
         //
         //
         //
                  
         if (ExitSignal > 0)
	      {
            if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*point,White); }
         }    
      
         //
         //
         //
         //
         //
             if (mode==OP_BUY && BreakEvenLong > 0)
             {
			         BuyStop = OrderStopLoss();
			         if (NormalizeDouble(Bid-OrderOpenPrice(),digit) > NormalizeDouble(Kz*BreakEvenLong*point,digit)) 
			         {
			            BuyStop=OrderOpenPrice()+((Kz-1)*BreakEvenLong+BreakEvenGapLong)*point;
			            OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(BuyStop, digit),OrderTakeProfit(),0,LightBlue);
			            Kz=Kz+1;
			            return(0);
			            }
			      }
			         
			      //
			      //
			      //
			      //
			      //
			      
               if (mode==OP_SELL && BreakEvenShort > 0)
                  {
                  SellStop = OrderStopLoss();
                  if (NormalizeDouble(OrderOpenPrice()-Ask,digit) > NormalizeDouble(Kz*BreakEvenShort*point,digit)) 
			         {
			            SellStop=OrderOpenPrice()-((Kz-1)*BreakEvenShort+BreakEvenGapShort)*point;
			            OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SellStop,digit),OrderTakeProfit(),0,Orange);
			            Kz=Kz+1;
			        return(0);
			        }
			   }
			         
           //
           //
           //
           //
           //
 
           if (TrailingStopMode > 0) 
           {
              if (mode == OP_BUY) 
              {
			     if (TrailingStop > 0)       BuyStop = Bid - TrailingStop*point;
			     else  if (StopSizeLong > 0) BuyStop = Smin1long; 
			                           else  BuyStop = OrderStopLoss();
			        
			        if (NormalizeDouble(BuyStop,digit) > NormalizeDouble(OrderStopLoss(),digit) || OrderStopLoss()==0) 
			        {
			        OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(BuyStop,digit),OrderTakeProfit(),0,LightGreen);
			        return(0);
                 }
              }
              
              // - SELL Orders 
              //
              //
              //
              //
                       
              if (mode == OP_SELL)
              {
              if (TrailingStop > 0)       SellStop = Ask + TrailingStop*point;
			     else if (StopSizeShort > 0) SellStop = Smax1short; 
                                    else  SellStop = OrderStopLoss(); 
               
                 if(NormalizeDouble(SellStop,digit) < NormalizeDouble(OrderStopLoss(),digit) || OrderStopLoss()==0) 
                 {
                 OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SellStop, digit),OrderTakeProfit(),0,Yellow);	    
                 return(0);
                 }
              }
           }
        }    
      }
      
      //
      //
      //
      //
      //  
		
		if (ScanTrades()<1)
		{
		double Lotsi=Lots;     
      double minlot = MarketInfo(s_symbol,MODE_MINLOT); 
      double lotstep = MarketInfo(s_symbol,MODE_LOTSTEP);
      
         if ( MM ) 
         {
         Lotsi=NormalizeDouble(Lots*AccountFreeMargin()*Risk/LossMax,2);   
         Lotsi=NormalizeDouble(Lotsi/lotstep,0)*lotstep;
         }
         if (Lotsi<minlot) Lotsi=minlot;          
		   
		   //
		   //
		   //
		   //
		   //
		   
		   if (trend>=0 && TradeSignal < 0 && TimeCondition) 
         {  
            
		      Type      = OP_SELL;
		    	Price     = Bid;
		  	   PriceStop = Ask; 
		  	   
		  	   if (InitialStopShort > 0)   SellStop = PriceStop + InitialStopShort*point; 
            else if( StopSizeShort > 0) SellStop = Smax1short; 
                                   else SellStop = 0;
            
            if (TakeProfitShort > 0)      SellProfit = Price - TakeProfitShort*point;
            else if (ProfitSizeShort > 0) SellProfit = bsmin1short; 
                                    else  SellProfit = 0;
            
            if (!EcnBroker)
            OrderSend(s_symbol,Type,Lotsi,NormalizeDouble(Price,digit),Slippage*point,NormalizeDouble(SellStop, digit),
		                       NormalizeDouble(SellProfit, digit),"sell",MAGIC,0,Red);
		      else
            {
		      int sellTicket=OrderSend(s_symbol,Type,Lotsi,NormalizeDouble(Price, digit),Slippage*point,0,0,"sell",MAGIC,0,Red);
		      if  (sellTicket  >= 0)
            bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),NormalizeDouble(SellStop, digit),NormalizeDouble(SellProfit,digit),0,CLR_NONE);
         
            Kz=1;
            if(SwingTrade) trend=-1; else {trend=0;}
            if (sellOrderMod  == false)
            {
            
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
            }
		      return(0);
		   }
		   
         // - BUY Orders
         //
         //
         //
         //
                  
	      if (trend <=0 &&  TradeSignal>0 && TimeCondition)
	      {
            
		      Type      = OP_BUY;
		      Price     = Ask;
		      PriceStop = Bid;
		   
		    	if (InitialStopLong > 0)   BuyStop = PriceStop - InitialStopLong*point; 
            else if (StopSizeLong > 0) BuyStop = Smin1long;
                                  else BuyStop = 0;
            
            if (TakeProfitLong > 0)      BuyProfit = Price + TakeProfitLong*point;
            else if (ProfitSizeLong > 0) BuyProfit = bsmax1long; 
                                    else BuyProfit = 0;
            
            if (!EcnBroker) 
		    	OrderSend(s_symbol,Type,Lotsi,NormalizeDouble(Price, digit),Slippage*point,NormalizeDouble(BuyStop,digit),
		    	         NormalizeDouble(BuyProfit, digit),"buy",MAGIC,0,Blue);
		    	else
            {
            int buyTicket = OrderSend(s_symbol,Type,Lotsi,NormalizeDouble(Price,digit),Slippage*point,0,0,"buy",MAGIC,0,Blue);
            if  (buyTicket >= 0)
            bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),NormalizeDouble(BuyStop, digit),NormalizeDouble(BuyProfit, digit),0,CLR_NONE);
               
            Kz=1;
            if(SwingTrade) trend=1; else {trend=0;}
            if (buyOrderMod  == false)
            {
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
           }
			 return(0);
         }
      }
      
    }

return(0);
}
  
//+------------------------------------------------------------------+
//
//
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == s_symbol && OrderType() <= OP_SELLSTOP && OrderMagicNumber() == MAGIC) 
   numords++;
   }
   return(numords);
}      

//
//
//
//
//

void TrailProfit()
{        
    int total=OrdersTotal();
    for (cnt=0;cnt<total;cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);   
     mode=OrderType();    
        if (OrderSymbol() == s_symbol && OrderMagicNumber()==MAGIC) 
        {
            if ( mode==OP_BUY )
            {
            if (ProfitSizeLong > 0) BuyProfit = bsmax1long;
                              else  BuyProfit = OrderTakeProfit();
         
              if(NormalizeDouble(BuyProfit,digit) > NormalizeDouble(OrderTakeProfit(),digit))
              { 
              OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(BuyProfit,digit),0,LightGreen);
			     return(0);
			     }
            }
            
            //
            //
            //
            //
            //
            
            if ( mode==OP_SELL )
            {
            if (ProfitSizeShort > 0) SellProfit = bsmin1short; 
                                else SellProfit = OrderTakeProfit();
   
              if(NormalizeDouble(SellProfit,digit) < NormalizeDouble(OrderTakeProfit(),digit))
              {  
   		     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(SellProfit,digit),0,Yellow);	    
              return(0);
              }
            }    
        }
    }   
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == "CADJPY") return(912991);
   if (s_symbol == "CADCHF") return(912992);
   
   if (s_symbol == "GOLD")   return(912991);
   if (s_symbol == "SILVER") return(912992);
   
   if (s_symbol == "NZDJPY") return(912991);
   if (s_symbol == "NZDUSD") return(912992);
   
   if (s_symbol == "CHFJPY") return(512991);
   
   if (s_symbol == "EURAUD") return(512991);
   if (s_symbol == "EURCAD") return(512992);
   if (s_symbol == "EURUSD") return(512997);
   if (s_symbol == "EURGBP") return(512994);
   if (s_symbol == "EURCHF") return(512975);
   if (s_symbol == "EURNZD") return(512976);
   if (s_symbol == "EURJPY") return(512977);
   
   if (s_symbol == "GBPUSD") return(512981);
   if (s_symbol == "GBPCHF") return(512982);
   if (s_symbol == "GBPJPY") return(512983);
   
   if (s_symbol == "USDCHF") return(512991);
   if (s_symbol == "USDJPY") return(512992);
   if (s_symbol == "USDCAD") return(512993);

   if (s_symbol == "AUDUSD") return(512901);
   if (s_symbol == "AUDNZD") return(512902);
   if (s_symbol == "AUDCAD") return(512903);
   if (s_symbol == "AUDCHF") return(512904);
   if (s_symbol == "AUDJPY") return(512205);
   
   return(ManualMagic);
}


